// -------------------------------------------------------------------------
// moc - Matlab/Octave Compatibility toolbox
// Copyright (C) 2010-2014  Holger Nahrstaedt
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//-------------------------------------------------------------------------
//
//  <-- NO CHECK ERROR OUTPUT -->
//

assert_checkequal(moc_unique([1 1 2; 1 2 1; 1 1 2]),[1;2])
assert_checkequal(moc_unique([1 1 2; 1 0 1; 1 1 2],'rows'),[1 0 1; 1 1 2])
assert_checkequal(moc_unique([]),[])
assert_checkequal(moc_unique([1]),[1])
assert_checkequal(moc_unique([1 2]),[1 2])
assert_checkequal(moc_unique([1;2]),[1;2])
assert_checkequal(moc_unique([1,%nan,%inf,%nan,%inf]),[1,%inf,%nan,%nan])
assert_checkequal(moc_unique({'Foo','Bar','Foo'}),{'Bar','Foo'})
assert_checkequal(moc_unique({'Foo','Bar','FooBar'}'),{'Bar','Foo','FooBar'}')

//test
 [a,i,j] = moc_unique([1,1,2,3,3,3,4]);
assert_checkequal(a,[1,2,3,4])
assert_checkequal(i,[2,3,6,7])
assert_checkequal(j,[1,1,2,3,3,3,4])
//
//test
 [a,i,j] = moc_unique([1,1,2,3,3,3,4]','first');
assert_checkequal(a,[1,2,3,4]')
assert_checkequal(i,[1,3,4,7]')
assert_checkequal(j,[1,1,2,3,3,3,4]')
//
//test
 [a,i,j] = moc_unique({'z'; 'z'; 'z'});
assert_checkequal(a,{'z'})
assert_checkequal(i,[3]')
assert_checkequal(j,[1,1,1]')
//
//test
 A=[1,2,3;1,2,3];
 [a,i,j] = moc_unique(A,2);
assert_checkequal(a,[1,2,3]')
assert_checkequal(A(i),a)
assert_checkequal(a(j),A(:))
